extends Node

const ExplosionScene = preload("./rocket_explosion.tscn")
#const DebrisScene = preload("./debris.tscn")

const TERRAIN_GROUP = "terrain"

onready var _camera = $Camera

var _random_time = 1.0


func _ready():
#	for i in 200:
	for i in 20:
		spawn_sphere()


func spawn_sphere():
	var pos = get_random_dir() * rand_range(20.0, 40.0)
	var mi = MeshInstance.new()
	mi.mesh = generate_sphere_mesh()
	mi.add_to_group(TERRAIN_GROUP)
	mi.translation = pos
	add_child(mi)


func generate_sphere_mesh():
	var mesh = SphereMesh.new()
	mesh.radial_segments = int(rand_range(6, 24))
	mesh.rings = int(rand_range(6, 24))
	mesh.radius = rand_range(5, 8)
	mesh.height = mesh.radius * 2
	return mesh


func _input(event):
	if event is InputEventMouseButton:
		if event.pressed:
			spawn_explosion()
			

func spawn_explosion():
	#return
	var pos = _camera.transform.origin - 25.0 * _camera.transform.basis.z
	var e = ExplosionScene.instance()
	e.translation = pos
	add_child(e)
	var mi = find_closest_terrain_mesh(e.translation)
	
	#e.queue_free()
	
	#if mi:
	#	destroy_mesh(mi)
	
#	if randf() < 0.5:
#		destroy_mesh(mi)
#	else:
#		alter_mesh(mi)




func _process(delta):
	
	_random_time -= delta
	if _random_time <= 0.0:
		#_random_time = rand_range(0.1, 1.0)
		#_random_time = rand_range(0.1, 0.2)
		_random_time = rand_range(0.02, 0.05)
		if randf() < -1.0: # 0.5
			#spawn_sphere()
			var dummy = 3
		else:
			var mi = find_closest_terrain_mesh(get_random_dir() * 20.0)
			if mi and (mi is MeshInstance):
				#if mi.is_queued_for_deletion() == false:
				alter_mesh(mi)
				#else:
				#	print("was queued for deletion")
			
#	if (Engine.get_frames_drawn() / 3) == 0:
#		var mi = find_closest_terrain_mesh(get_random_dir() * 20.0)
#		alter_mesh(mi)
		


#func destroy_mesh(mi: MeshInstance):
#	mi.mesh = null
#	mi.queue_free()	


func alter_mesh(mi: MeshInstance):
	mi.mesh = generate_sphere_mesh()


func find_closest_terrain_mesh(pos: Vector3) -> MeshInstance:
	var closest_instance = null
	var closest_distance := 10000.0
	var terrain_mesh_instances = get_tree().get_nodes_in_group(TERRAIN_GROUP)
	for mi in terrain_mesh_instances:
		var d = mi.translation.distance_to(pos)
		if d < closest_distance:
			closest_instance = mi
			closest_distance = d
	return closest_instance
	


static func get_random_dir() -> Vector3:
	return Vector3(rand_range(-1, 1), rand_range(-1, 1), rand_range(-1, 1)).normalized()
